<html>
<head>
<title>Ogre::EdgeListBuilder Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1EdgeListBuilder.html">EdgeListBuilder</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::EdgeListBuilder Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::EdgeListBuilder" -->
<p>General utility class for building edge lists for geometry.  
 <a href="classOgre_1_1EdgeListBuilder.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>&gt;</code></p>

<p><a href="classOgre_1_1EdgeListBuilder-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">CommonVertex</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A vertex can actually represent several vertices in the final model, because vertices along texture seams etc will have been duplicated.  <a href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A set of indexed geometry data.  <a href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html">geometryLess</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparator for sorting geometries by vertex set.  <a href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">vectorLess</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparator for unique vertex list.  <a href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#acf52bd519947f6f8305df1bec3247dd2">EdgeListBuilder</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#af699fd3c27f017e3625b93182dfba122">~EdgeListBuilder</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a9845e2f91660819164a627c661f5d107">addVertexData</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *vertexData)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a set of vertex geometry data to the edge builder.  <a href="#a9845e2f91660819164a627c661f5d107"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#ae4af3550dfe4948680078a087377bfbf">addIndexData</a> (const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *indexData, size_t vertexSet=0, <a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a> opType=<a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087">RenderOperation::OT_TRIANGLE_LIST</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a set of index geometry data to the edge builder.  <a href="#ae4af3550dfe4948680078a087377bfbf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a7233d617fe953b3b6c74035636f1d9f0">build</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Builds the edge information based on the information built up so far.  <a href="#a7233d617fe953b3b6c74035636f1d9f0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a66aa1d48de5385be8233c8733af99186">log</a> (<a class="el" href="classOgre_1_1Log.html">Log</a> *l)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Debugging method.  <a href="#a66aa1d48de5385be8233c8733af99186"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; const <br class="typebreak"/>
<a class="el" href="classOgre_1_1VertexData.html">VertexData</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">VertexDataList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">GeometryList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">CommonVertex</a> &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">CommonVertexList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="classOgre_1_1Vector3.html">Vector3</a>, size_t, <br class="typebreak"/>
<a class="el" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">vectorLess</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8">CommonVertexMap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map for identifying common vertices.  <a href="#aab99422a5b615f1a8babca94ce3139a8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1multimap.html">multimap</a>&lt; std::pair<br class="typebreak"/>
&lt; size_t, size_t &gt;, std::pair<br class="typebreak"/>
&lt; size_t, size_t &gt; &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac">EdgeMap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Edge map, used to connect edges.  <a href="#a8a45099b2356182b6e42e9659ea2acac"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a931b3ad77134a61a22a64492fdb898bf">buildTrianglesEdges</a> (const <a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a> &amp;geometry)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#adfa93b810bd70c02bc04899851677e52">findOrCreateCommonVertex</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;vec, size_t vertexSet, size_t indexSet, size_t originalIndex)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds an existing common vertex, or inserts a new one.  <a href="#adfa93b810bd70c02bc04899851677e52"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a5ea7b21ba4d92d2d9a73c0ac8e2d11ce">connectOrCreateEdge</a> (size_t vertexSet, size_t triangleIndex, size_t vertIndex0, size_t vertIndex1, size_t sharedVertIndex0, size_t sharedVertIndex1)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect existing edge or create a new edge - utility method during building.  <a href="#a5ea7b21ba4d92d2d9a73c0ac8e2d11ce"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">GeometryList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a5d4989a248aa1f8fc2f42d278aa708f0">mGeometryList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">VertexDataList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#ac706c9ac2d689aa08556ba824386c97a">mVertexDataList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">CommonVertexList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a2b2c21a40cd9ce67461bd0164fe67a35">mVertices</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a8cc80f94959971521a82cc930cac46e9">mEdgeData</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8">CommonVertexMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a43c5862bbe8afebf7ca473fbcbf219e0">mCommonVertexMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac">EdgeMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a49964dbb7e73349bed694df63ec9b372">mEdgeMap</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>General utility class for building edge lists for geometry. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>You can add multiple sets of vertex and index data to build and edge list. Edges will be built between the various sets as well as within sets; this allows you to use a model which is built from multiple SubMeshes each using separate index and (optionally) vertex data and still get the same connectivity information. It's important to note that the indexes for the edge will be constrained to a single vertex buffer though (this is required in order to render the edge). </dd></dl>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00163">163</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a403ee411b89442d5561c15e2798344b2"></a><!-- doxytag: member="Ogre::EdgeListBuilder::CommonVertexList" ref="a403ee411b89442d5561c15e2798344b2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">CommonVertex</a>&gt;::type <a class="el" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">Ogre::EdgeListBuilder::CommonVertexList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00240">240</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="aab99422a5b615f1a8babca94ce3139a8"></a><!-- doxytag: member="Ogre::EdgeListBuilder::CommonVertexMap" ref="aab99422a5b615f1a8babca94ce3139a8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="classOgre_1_1Vector3.html">Vector3</a>, size_t, <a class="el" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">vectorLess</a>&gt;::type <a class="el" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8">Ogre::EdgeListBuilder::CommonVertexMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map for identifying common vertices. </p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00247">247</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8a45099b2356182b6e42e9659ea2acac"></a><!-- doxytag: member="Ogre::EdgeListBuilder::EdgeMap" ref="a8a45099b2356182b6e42e9659ea2acac" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1multimap.html">multimap</a>&lt; std::pair&lt;size_t, size_t&gt;, std::pair&lt;size_t, size_t&gt; &gt;::type <a class="el" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac">Ogre::EdgeListBuilder::EdgeMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Edge map, used to connect edges. </p>
<p>Note we allow many triangles on an edge, after connected an existing edge, we will remove it and never used again. </p>

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00252">252</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9d13398484a0dc3db6cdf5d026e22610"></a><!-- doxytag: member="Ogre::EdgeListBuilder::GeometryList" ref="a9d13398484a0dc3db6cdf5d026e22610" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a>&gt;::type <a class="el" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">Ogre::EdgeListBuilder::GeometryList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00239">239</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1cf79a018c3d394a681a705968b8cb29"></a><!-- doxytag: member="Ogre::EdgeListBuilder::VertexDataList" ref="a1cf79a018c3d394a681a705968b8cb29" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a>*&gt;::type <a class="el" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">Ogre::EdgeListBuilder::VertexDataList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00238">238</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="acf52bd519947f6f8305df1bec3247dd2"></a><!-- doxytag: member="Ogre::EdgeListBuilder::EdgeListBuilder" ref="acf52bd519947f6f8305df1bec3247dd2" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#acf52bd519947f6f8305df1bec3247dd2">Ogre::EdgeListBuilder::EdgeListBuilder</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="af699fd3c27f017e3625b93182dfba122"></a><!-- doxytag: member="Ogre::EdgeListBuilder::~EdgeListBuilder" ref="af699fd3c27f017e3625b93182dfba122" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1EdgeListBuilder.html#af699fd3c27f017e3625b93182dfba122">Ogre::EdgeListBuilder::~EdgeListBuilder</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ae4af3550dfe4948680078a087377bfbf"></a><!-- doxytag: member="Ogre::EdgeListBuilder::addIndexData" ref="ae4af3550dfe4948680078a087377bfbf" args="(const IndexData *indexData, size_t vertexSet=0, RenderOperation::OperationType opType=RenderOperation::OT_TRIANGLE_LIST)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1EdgeListBuilder.html#ae4af3550dfe4948680078a087377bfbf">Ogre::EdgeListBuilder::addIndexData</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&#160;</td>
          <td class="paramname"><em>indexData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>vertexSet</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d">RenderOperation::OperationType</a>&#160;</td>
          <td class="paramname"><em>opType</em> = <code><a class="el" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087">RenderOperation::OT_TRIANGLE_LIST</a></code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a set of index geometry data to the edge builder. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>You must add at least one set of index data to the builder before invoking the build method. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">indexData</td><td>The index information which describes the triangles. </td></tr>
    <tr><td class="paramname">vertexSet</td><td>The vertex data set this index data refers to; you only need to alter this if you have added multiple sets of vertices </td></tr>
    <tr><td class="paramname">opType</td><td>The operation type used to render these indexes. Only triangle types are supported (no point or line types) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9845e2f91660819164a627c661f5d107"></a><!-- doxytag: member="Ogre::EdgeListBuilder::addVertexData" ref="a9845e2f91660819164a627c661f5d107" args="(const VertexData *vertexData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1EdgeListBuilder.html#a9845e2f91660819164a627c661f5d107">Ogre::EdgeListBuilder::addVertexData</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&#160;</td>
          <td class="paramname"><em>vertexData</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a set of vertex geometry data to the edge builder. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>You must add at least one set of vertex data to the builder before invoking the build method. </dd></dl>

</div>
</div>
<a class="anchor" id="a7233d617fe953b3b6c74035636f1d9f0"></a><!-- doxytag: member="Ogre::EdgeListBuilder::build" ref="a7233d617fe953b3b6c74035636f1d9f0" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a>* <a class="el" href="classOgre_1_1EdgeListBuilder.html#a7233d617fe953b3b6c74035636f1d9f0">Ogre::EdgeListBuilder::build</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Builds the edge information based on the information built up so far. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The caller takes responsibility for deleting the returned structure. </dd></dl>

</div>
</div>
<a class="anchor" id="a931b3ad77134a61a22a64492fdb898bf"></a><!-- doxytag: member="Ogre::EdgeListBuilder::buildTrianglesEdges" ref="a931b3ad77134a61a22a64492fdb898bf" args="(const Geometry &amp;geometry)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1EdgeListBuilder.html#a931b3ad77134a61a22a64492fdb898bf">Ogre::EdgeListBuilder::buildTrianglesEdges</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">Geometry</a> &amp;&#160;</td>
          <td class="paramname"><em>geometry</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a5ea7b21ba4d92d2d9a73c0ac8e2d11ce"></a><!-- doxytag: member="Ogre::EdgeListBuilder::connectOrCreateEdge" ref="a5ea7b21ba4d92d2d9a73c0ac8e2d11ce" args="(size_t vertexSet, size_t triangleIndex, size_t vertIndex0, size_t vertIndex1, size_t sharedVertIndex0, size_t sharedVertIndex1)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1EdgeListBuilder.html#a5ea7b21ba4d92d2d9a73c0ac8e2d11ce">Ogre::EdgeListBuilder::connectOrCreateEdge</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>vertexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>triangleIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>vertIndex0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>vertIndex1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sharedVertIndex0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sharedVertIndex1</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Connect existing edge or create a new edge - utility method during building. </p>

</div>
</div>
<a class="anchor" id="adfa93b810bd70c02bc04899851677e52"></a><!-- doxytag: member="Ogre::EdgeListBuilder::findOrCreateCommonVertex" ref="adfa93b810bd70c02bc04899851677e52" args="(const Vector3 &amp;vec, size_t vertexSet, size_t indexSet, size_t originalIndex)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1EdgeListBuilder.html#adfa93b810bd70c02bc04899851677e52">Ogre::EdgeListBuilder::findOrCreateCommonVertex</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>vec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>vertexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>indexSet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>originalIndex</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Finds an existing common vertex, or inserts a new one. </p>

</div>
</div>
<a class="anchor" id="a66aa1d48de5385be8233c8733af99186"></a><!-- doxytag: member="Ogre::EdgeListBuilder::log" ref="a66aa1d48de5385be8233c8733af99186" args="(Log *l)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1EdgeListBuilder.html#a66aa1d48de5385be8233c8733af99186">Ogre::EdgeListBuilder::log</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Log.html">Log</a> *&#160;</td>
          <td class="paramname"><em>l</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Debugging method. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a43c5862bbe8afebf7ca473fbcbf219e0"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mCommonVertexMap" ref="a43c5862bbe8afebf7ca473fbcbf219e0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8">CommonVertexMap</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#a43c5862bbe8afebf7ca473fbcbf219e0">Ogre::EdgeListBuilder::mCommonVertexMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00248">248</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8cc80f94959971521a82cc930cac46e9"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mEdgeData" ref="a8cc80f94959971521a82cc930cac46e9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a>* <a class="el" href="classOgre_1_1EdgeListBuilder.html#a8cc80f94959971521a82cc930cac46e9">Ogre::EdgeListBuilder::mEdgeData</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00245">245</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a49964dbb7e73349bed694df63ec9b372"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mEdgeMap" ref="a49964dbb7e73349bed694df63ec9b372" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac">EdgeMap</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#a49964dbb7e73349bed694df63ec9b372">Ogre::EdgeListBuilder::mEdgeMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00253">253</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5d4989a248aa1f8fc2f42d278aa708f0"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mGeometryList" ref="a5d4989a248aa1f8fc2f42d278aa708f0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">GeometryList</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#a5d4989a248aa1f8fc2f42d278aa708f0">Ogre::EdgeListBuilder::mGeometryList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00242">242</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac706c9ac2d689aa08556ba824386c97a"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mVertexDataList" ref="ac706c9ac2d689aa08556ba824386c97a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">VertexDataList</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#ac706c9ac2d689aa08556ba824386c97a">Ogre::EdgeListBuilder::mVertexDataList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00243">243</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2b2c21a40cd9ce67461bd0164fe67a35"></a><!-- doxytag: member="Ogre::EdgeListBuilder::mVertices" ref="a2b2c21a40cd9ce67461bd0164fe67a35" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">CommonVertexList</a> <a class="el" href="classOgre_1_1EdgeListBuilder.html#a2b2c21a40cd9ce67461bd0164fe67a35">Ogre::EdgeListBuilder::mVertices</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreEdgeListBuilder_8h_source.html#l00244">244</a> of file <a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreEdgeListBuilder_8h_source.html">OgreEdgeListBuilder.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:55
</p>
</body>
</html>
